package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineCointonetwork struct {
	api.Api
}

// GetPage 获取币种与网络关系列表
// @Summary 获取币种与网络关系列表
// @Description 获取币种与网络关系列表
// @Tags 币种与网络关系
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineCointonetwork}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-cointonetwork [get]
// @Security Bearer
func (e LineCointonetwork) GetPage(c *gin.Context) {
    req := dto.LineCointonetworkGetPageReq{}
    s := service.LineCointonetwork{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineCointonetwork, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取币种与网络关系失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取币种与网络关系
// @Summary 获取币种与网络关系
// @Description 获取币种与网络关系
// @Tags 币种与网络关系
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineCointonetwork} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-cointonetwork/{id} [get]
// @Security Bearer
func (e LineCointonetwork) Get(c *gin.Context) {
	req := dto.LineCointonetworkGetReq{}
	s := service.LineCointonetwork{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineCointonetwork

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取币种与网络关系失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建币种与网络关系
// @Summary 创建币种与网络关系
// @Description 创建币种与网络关系
// @Tags 币种与网络关系
// @Accept application/json
// @Product application/json
// @Param data body dto.LineCointonetworkInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-cointonetwork [post]
// @Security Bearer
func (e LineCointonetwork) Insert(c *gin.Context) {
    req := dto.LineCointonetworkInsertReq{}
    s := service.LineCointonetwork{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建币种与网络关系失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改币种与网络关系
// @Summary 修改币种与网络关系
// @Description 修改币种与网络关系
// @Tags 币种与网络关系
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineCointonetworkUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-cointonetwork/{id} [put]
// @Security Bearer
func (e LineCointonetwork) Update(c *gin.Context) {
    req := dto.LineCointonetworkUpdateReq{}
    s := service.LineCointonetwork{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改币种与网络关系失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除币种与网络关系
// @Summary 删除币种与网络关系
// @Description 删除币种与网络关系
// @Tags 币种与网络关系
// @Param data body dto.LineCointonetworkDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-cointonetwork [delete]
// @Security Bearer
func (e LineCointonetwork) Delete(c *gin.Context) {
    s := service.LineCointonetwork{}
    req := dto.LineCointonetworkDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除币种与网络关系失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
